/*********************************************************/
/* BMPASS.C - program to set the level number in BRAM,   */
/*            for the game Bomberman (both JPN and USA)  */
/*                                                       */
/* Written on August 9, 2001 by Dave Shadoff             */
/*                                                       */
/*********************************************************/

#include "huc.h"


/************************************/
/* filnames of backup files in BRAM */
/************************************/

#define BNAME_BMAN	"BOMBERMAN1"

const char bomb_name[] = { "BOMBERMAN1", 0 };


int bram_found;
int bram_free;

char bm_buffer[10];

char bm_name[13];

int area, level, bombs, power, speed;

main()
{
   int choice;
   int i;

/*   set_xres(328); */

   set_color(0,0);
   set_color(1,511);

   bm_name[0] = 0;
   bm_name[1] = 0;
   strcpy(&bm_name[2], BNAME_BMAN);
   bm_name[12] = 0;

   put_string("Backup RAM Generator", 4, 2);
   put_string("For: Bomberman (JPN/USA)", 5, 4);

   while (1) {
      choice = choose_entry();

      area = 1;
      level = 1;
      bombs = 1;
      power = 1;
      speed = 0;
      set_bram();

      put_string("                                ", 1, 13);
      put_string("                                ", 1, 14);
      put_string("                                ", 1, 15);
      put_string("                                ", 1, 16);
      put_string("                                ", 1, 17);
   }
}

#define CHOOSE_1	13
#define CHOOSE_2	15

choose_entry()
{
   int key, select;

   select = 1;
   
   put_string("Set Level in BRAM", 5, CHOOSE_1);
   put_string("Bomberman slot 1", 5, CHOOSE_2);

   while(1)
   {
      put_number(select, 1, 20, CHOOSE_2);

      bm_name[11] = select + '0';

      if (bm_exist(&bm_name[0]))
         put_string("(exists)", 23, CHOOSE_2);
      else
         put_string("        ", 23, CHOOSE_2);

      key = 0;
      while (key == 0) {
         key = joytrg(0);
      }

      if ((key == JOY_LEFT) && (select > 1))
         select--;

      if ((key == JOY_RGHT) && (select < 3))
         select++;

      if ((key == JOY_STRT) || (key == JOY_A))
         break;

      vsync(0);
   }

   put_string("                              ", 3, CHOOSE_1);
   put_string("                              ", 3, CHOOSE_2);

   return(select);
}



#define SELECT_AREA	13
#define SELECT_LEVEL	14
#define SELECT_BOMBS	15
#define SELECT_POWER	16
#define SELECT_SPEED	17
#define SELECT_PASSWD	19

select_level()
{
   int key, select;
   int i;

   select = 0;

   vsync(0);

   put_string("Area:",  5, SELECT_AREA);
   put_string("Level:", 5, SELECT_LEVEL);
   put_string("Bombs:", 5, SELECT_BOMBS);
   put_string("Power:", 5, SELECT_POWER);
   put_string("Speed:", 5, SELECT_SPEED);

   while (1)
   {
      put_number(area,  2, 12, SELECT_AREA);
      put_number(level, 2, 12, SELECT_LEVEL);
      put_number(bombs, 2, 12, SELECT_BOMBS);
      put_number(power, 2, 12, SELECT_POWER);
      put_number(speed, 2, 12, SELECT_SPEED);

      for (i= 0; i < 5; i++)
         put_string(" ", 3, SELECT_AREA+i);

      put_string(">", 3, SELECT_AREA + select);

      key = 0;
      while (key == 0) {
         key = joytrg(0);
      }

      if ((key == JOY_UP) && (select > 0)) {
         select--;
      }

      if ((key == JOY_DOWN) && (select < 4)) {
         select++;
      }


      if (key == JOY_LEFT)
      {
         switch (select) {

           case 0:
              if (area > 1)
                area--;
              break;
         
           case 1:
              if (level > 1)
                level--;
              break;
         
           case 2:
              if (bombs > 1)
                bombs--;
              break;
         
           case 3:
              if (power > 1)
                power--;
              break;
         
           case 4:
              if (speed > 1)
                speed--;
              break;
         }
      }

      if (key == JOY_RGHT)
      {
         switch (select) {

           case 0:
              if (area < 8)
                area++;
              break;

           case 1:
              if (level < 8)
                level++;
              break;

           case 2:
              if (bombs < 16)
                bombs++;
              break;

           case 3:
              if (power < 30)
                power++;
              break;

           case 4:
              if (speed < 1)
                speed++;
              break;

         }
      }

      if ((key == JOY_A) || (key == JOY_STRT) || (key == JOY_B))
      {
         break;
      }

      put_string("                              ", 2, SELECT_PASSWD);
      put_string("                              ", 2, SELECT_PASSWD+1);

      vsync(0);
   }

   if (key == JOY_B)
      return(-1);

   else
      return(0);
}


set_bram()
{
   int game, key, index, bram_found;


   bram_found = bm_check();

   vsync(0);

   if (! bram_found)
   {
      put_string("Backup memory not found", 5, 13);
      while (joytrg(0) != JOY_STRT);
      put_string("                       ", 5, 13);
      return(0);
   }

   bram_free = bm_free();
   if (bm_errno())
   {
      put_string("Backup memory not formatted", 3, 13);
      put_string("Press  I to format", 5, 15);
      put_string("Or    II to return to menu", 5, 16);

      key = 0;
      while ((key != JOY_A) && (key != JOY_B))
         key = joytrg(0);

      put_string("                           ", 3, 13);
      put_string("                           ", 3, 15);
      put_string("                           ", 3, 16);

      if (key == JOY_B)
         return(0);

      bm_format();
      bram_free = bm_free();
      if (bm_errno())
      {
         put_string("There was a problem", 5, 13);
         put_string("during formatting", 5, 14);
         put_string("Please check your hardware", 5, 16);
         while (joytrg(0) != JOY_STRT);
         put_string("                   ", 5, 13);
         put_string("                 ", 5, 14);
         put_string("                          ", 5, 16);
         return(0);
      }
   }


   if (bm_exist(bm_name))
   {
      bm_read(bm_buffer, bm_name, 0, 5);
      area  = bm_buffer[0] + 1;
      level = bm_buffer[1] + 1;
      bombs = bm_buffer[2];
      power = bm_buffer[3];
      speed = bm_buffer[4];
   }
   else
   {
      bram_free = bm_free();

      if (bram_free < 5)
      {
         put_string("Not enough memory", 5, 13);
         put_string("Please check your hardware", 5, 16);
         while (joytrg(0) != JOY_STRT);
         put_string("                 ", 5, 13);
         put_string("                          ", 5, 16);
         return(0);
      }

      bm_create(bm_name, 5);

      bm_buffer[0] = area - 1;
      bm_buffer[1] = level - 1;
      bm_buffer[2] = bombs;
      bm_buffer[3] = power;
      bm_buffer[4] = speed;

      bm_write(bm_buffer, bm_name, 0, 5);
   }

   while(1)
   {
      index = select_level();

      if (index == -1)
         break;

      put_string("Level set in BRAM", 5, SELECT_PASSWD);

      bm_buffer[0] = area  - 1;
      bm_buffer[1] = level - 1;
      bm_buffer[2] = bombs;
      bm_buffer[3] = power;
      bm_buffer[4] = speed;

      bm_write(bm_buffer, bm_name, 0, 5);
   }

   return;
}

